// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/om"
	common "LAPP_LF_MOM_BACKEND/models/base"
	model "LAPP_LF_MOM_BACKEND/models/om"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : SerialOrderStatusRecLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : SerialOrderStatusRecLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-20 13:07:32
 *
 ******************************************************************************/
type SerialOrderStatusRecLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewSerialOrderStatusRecLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个SerialOrderStatusRecLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : SerialOrderStatusRecLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-20 13:07:32
 *
 ******************************************************************************/
func NewSerialOrderStatusRecLstDAOImplement(session *xorm.Session, plantNr int, userid string) *SerialOrderStatusRecLstDAOImplement {
	return &SerialOrderStatusRecLstDAOImplement{session, &meta.SerialOrderStatusRecLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) InsertOne(entity *model.SerialOrderStatusRecLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) DeleteOne(serialOrderId string, pos int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, serialOrderId, pos}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) SelectOne(serialOrderId string, pos int) (*model.SerialOrderStatusRecLst, error) {
	var data model.SerialOrderStatusRecLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, serialOrderId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) UpdateOne(entity *model.SerialOrderStatusRecLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.Insert
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) Insert(entities *[]model.SerialOrderStatusRecLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.Delete
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) Delete(entities *[]model.SerialOrderStatusRecLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.Select
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.SerialOrderStatusRecLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.SerialOrderStatusRecLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.SerialOrderStatusRecLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.SerialOrderStatusRecLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.SerialOrderStatusRecLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.Update
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) Update(entities *[]model.SerialOrderStatusRecLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.SerialOrderStatusRecLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.SerialOrderStatusRecLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) SelectByEvent(event string) (datalst []model.SerialOrderStatusRecLst, err error) {
	session := impl.session.Table(impl.meta.TableName)
	/**主键：****/
	if err = session.Where("PlantNr = ? and OutputEvent = ? and OutputStatus = ?",impl.plantNr, event, common.OUTPUT_TRIGGER_UNHANDLED).OrderBy("CreateTime").Find(&datalst); err != nil {
		return
	}
	return
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.GetMaxPos
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) GetMaxPos(serialOrderId string) (maxPos int, err error) {
	session := impl.session.Table(impl.meta.TableName)
	where := fmt.Sprintf("%s = ? and %s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName, meta.SerialOrderStatusRecLst_SerialOrderId.ColumnName)
	exist, err := session.Where(where, impl.plantNr, serialOrderId).Desc(meta.SerialOrderStatusRecLst_Pos.ColumnName).Cols(meta.SerialOrderStatusRecLst_Pos.ColumnName).Limit(1).Get(&maxPos)
	if err != nil {
		return 0, err
	}
	if !exist {
		maxPos = 0
	}
	return maxPos, nil
}


/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/SerialOrderStatusRecLstDAO.GetSerialOrderToMes
 *
 ******************************************************************************/
func (impl *SerialOrderStatusRecLstDAOImplement) GetSerialOrderToMes() (result []model.VOmSerialOrderJoinRec, err error) {
	session := impl.session.Table(impl.meta.TableName)
	statusRecLi := make([]model.SerialOrderStatusRecLst, 0, model.MesOutputNum)
	session = session.Where(fmt.Sprintf("%s = ?", meta.SerialOrderStatusRecLst_PlantNr.ColumnName), impl.plantNr)
	where := fmt.Sprintf("%s = ? and %s = ? and %s = ? and %s < ?",
		meta.SerialOrderStatusRecLst_Status.ColumnName,
		meta.SerialOrderStatusRecLst_OutputEvent.ColumnName,
		meta.SerialOrderStatusRecLst_OutputStatus.ColumnName,
		meta.SerialOrderStatusRecLst_OutputErrNum.ColumnName)

	session = session.Where(where, common.WO_STATUS_RELEASED, common.SERORD_EVENT_RELEASE, common.OUTPUT_TRIGGER_UNHANDLED, model.MesOutputRetryNum).Asc(meta.SerialOrderStatusRecLst_SerialOrderId.ColumnName)

	err = session.Limit(model.MesOutputNum).Find(&statusRecLi)
	if err != nil {
		return nil, err
	}
	recMap := make(map[string]model.SerialOrderStatusRecLst)
	serialOrderIds := make([]string, 0, len(statusRecLi))
	for _, data := range statusRecLi {
		serialOrderIds = append(serialOrderIds, data.SerialOrderId)
		recMap[data.SerialOrderId] = data
	}
	serialOrderLi := make([]model.SerialOrder, 0, len(statusRecLi))
	serialOrderSession := impl.session.Table(meta.SerialOrder.TableName)
	serialOrderSession = serialOrderSession.Where(fmt.Sprintf("%s = ?", meta.SerialOrder_PlantNr.ColumnName), impl.plantNr)
	err = serialOrderSession.In(meta.SerialOrder_SerialOrderId.ColumnName, serialOrderIds).Asc(meta.SerialOrder_SerialOrderId.ColumnName).Find(&serialOrderLi)
	if err != nil {
		return nil, err
	}
	result = make([]model.VOmSerialOrderJoinRec, 0, len(serialOrderLi))
	for _, serialOrder := range serialOrderLi {
		var serialOrderJoin model.VOmSerialOrderJoinRec
		statusRec := recMap[serialOrder.SerialOrderId]
		serialOrderJoin.StatusRec = statusRec
		serialOrderJoin.SerialOrder = serialOrder
		result = append(result, serialOrderJoin)
	}
	return result, nil
}